unit HeaderControl;
interface
uses
  System.Data, System.Drawing, System.Web, System.Web.UI,
  System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  LoginControl, LogoutControl;

type
    /// <summary>
    /// Summary description for WebUserControl1.
    /// </summary>
  HeaderUserControl = class(System.Web.UI.UserControl)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    lbHeader: System.Web.UI.WebControls.Label;
    procedure OnInit(e: System.EventArgs); override;
  private
    MyLoginControl: LoginUserControl;
    MyLogoutControl: LogoutUserControl;
  protected
    procedure Login(Sender: System.Object; e: LoginEventArgs);
    procedure Logout(Sender: System.Object; e: EventArgs);
  public
    function get_Header: String;
    procedure set_Header(const Value: String);
    { Private Declarations }
  public
    { Public Declarations }
    property Header: String read get_Header write set_Header;
  end;

implementation
 
procedure HeaderUserControl.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  // TODO: Put user code to initialize the page here
end;

procedure HeaderUserControl.OnInit(e: System.EventArgs);
begin
  //
  // Required for Designer support
  //
  InitializeComponent;
  MyLoginControl := Self.FindControl('UserControl1') as LoginUserControl;
  MyLogoutControl := Self.FindControl('UserControl2') as LogoutUserControl;
  if Page.User.Identity.Name = '' then // no login, yet
  begin
    Include(MyLoginControl.Login, Self.Login);
    MyLogoutControl.Visible := False
  end
  else
  begin
    Include(MyLogoutControl.Logout, Self.Logout);
    MyLoginControl.Visible := False
  end;
  inherited OnInit(e);
end;

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure HeaderUserControl.InitializeComponent;
begin
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}


function HeaderUserControl.get_Header: String;
begin
  Result := lbheader.Text
end;

procedure HeaderUserControl.set_Header(const Value: String);
begin
  lbHeader.Text := Value
end;

procedure HeaderUserControl.Logout(Sender: TObject; e: EventArgs);
begin
  MyLogoutControl.Visible := False;
  MyLoginControl.Visible := True;
end;

procedure HeaderUserControl.Login(Sender: TObject; e: LoginEventArgs);
begin
  MyLoginControl.Visible := False;
  MyLogoutControl.LoginName := e.Username;
  MyLogoutControl.Visible := True;
end;

end.
