unit LoginControl;
interface
uses System.Data, System.Drawing, System.Web, System.Web.UI,
     System.Web.UI.WebControls, System.Web.UI.HtmlControls;

type
  LoginEventArgs = class(EventArgs)
  private
    FUsername: String;
  public
    property Username: String read FUsername write FUsername;
  end;

  LoginHandler = procedure (Sender: System.Object; e: LoginEventArgs) of object;

    /// <summary>
    /// Summary description for WebUserControl1.
    /// </summary>
  LoginUserControl = class(System.Web.UI.UserControl)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure btnLogin_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    tbUsername: System.Web.UI.WebControls.TextBox;
    tbpassword: System.Web.UI.WebControls.TextBox;
    btnLogin: System.Web.UI.WebControls.Button;
    lbLogin: System.Web.UI.WebControls.Label;
    procedure OnInit(e: System.EventArgs); override;
  private
    { Private Declarations }
    FLogin: LoginHandler;
  public
    { Public Declarations }
    property Login: LoginHandler add FLogin remove FLogin;
  end;

implementation
uses
  System.Web.Security;

procedure LoginUserControl.Page_Load(sender: System.Object; e: System.EventArgs);
begin
  // TODO: Put user code to initialize the page here
end;

procedure LoginUserControl.OnInit(e: System.EventArgs);
begin
  //
  // Required for Designer support
  //
  InitializeComponent;
  inherited OnInit(e);
end;

procedure LoginUserControl.btnLogin_Click(sender: System.Object; e: System.EventArgs);
var
  LoginArgs: LoginEventArgs;
begin
  lbLogin.Text := ''; // Clear
  if FormsAuthentication.Authenticate(tbUsername.Text,tbPassword.Text) then
  begin
    FormsAuthentication.SetAuthCookie(tbUsername.Text, False);
    if Assigned(FLogin) then
    begin
      LoginArgs := LoginEventArgs.Create;
      LoginArgs.Username := tbUsername.Text;
      FLogin(Sender, LoginArgs)
    end
  end
  else
    lbLogin.Text := 'Login incorrect!'
end;

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure LoginUserControl.InitializeComponent;
begin
  Include(Self.btnLogin.Click, Self.btnLogin_Click);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}


end.
