unit Oblong.Design.HelpFileProperty;

interface

uses
  Borland.Vcl.Design.DesignIntf, Borland.Vcl.Design.DesignEditors;

type
  THelpFileProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

implementation

uses
  Dialogs;

{ THelpFileProperty }

procedure THelpFileProperty.Edit;
begin
  with TOpenDialog.Create(nil) do
    try
      FileName := Value;
      Title := 'Pick a help file';
      Filter := 'Help files (*.hlp)|*.hlp';
      DefaultExt := '.hlp';
      Options := Options + [ofPathMustExist, ofFileMustExist] - [ofShowHelp];
      if Execute then
        Value := FileName
    finally
      Free
    end
end;

function THelpFileProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog, paMultiSelect]
end;

end.
