unit eBob42.DBControls;
interface
uses
  DB, DBCtrls;

type 
  IDataAware = interface
  // private in base classes
  //function GetDataSource: TDataSource;
  //procedure SetDataSource(const Value: TDataSource);
  //function GetDataField: String;
  //procedure SetDataField(const Value: String);

    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property DataField: String read GetDataField write SetDataField;
  end;

type
  TIDBText = class(TDBText, IDataAware)
  public
    function IDataAware.GetDataField = TDBText.GetDataField: String;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: String);
    procedure SetDataSource(const Value: TDataSource);
  end;
  TIDBEdit = class(TDBEdit, IDataAware)
  public
    function GetDataField: String;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: String);
    procedure SetDataSource(const Value: TDataSource);
  end;
  TIDBMemo = class(TDBMemo, IDataAware)
  public
    function GetDataField: String;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: String);
    procedure SetDataSource(const Value: TDataSource);
  end;
  TIDBImage = class(TDBImage, IDataAware)
  public
    function GetDataField: String;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: String);
    procedure SetDataSource(const Value: TDataSource);
  end;
  TIDBListBox = class(TDBListBox, IDataAware)
  public
    function GetDataField: String;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: String);
    procedure SetDataSource(const Value: TDataSource);
  end;
  TIDBComboBox = class(TDBComboBox, IDataAware)
  public
    function GetDataField: String;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: String);
    procedure SetDataSource(const Value: TDataSource);
  end;
  TIDBCheckBox = class(TDBCheckBox, IDataAware)
  public
    function GetDataField: String;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: String);
    procedure SetDataSource(const Value: TDataSource);
  end;
  TIDBRadioGroup = class(TDBRadioGroup, IDataAware)
  public
    function GetDataField: String;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: String);
    procedure SetDataSource(const Value: TDataSource);
  end;
  TIDBRichEdit = class(TDBRichEdit, IDataAware)
  public
    function GetDataField: String;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: String);
    procedure SetDataSource(const Value: TDataSource);
  end;

implementation

end.